set nocompatible
syntax on

" Editing settings
set expandtab  " use spaces
set tabstop=4
set shiftwidth=4
set scrolloff=2

" Editor UI
set number relativenumber
set ruler
set cc=80
colorscheme zaibatsu

" netrw
let g:netrw_altv=1          " split window to the right
let g:netrw_liststyle=3     " tree style listing
let g:netrw_list_hide=netrw_gitignore#Hide() 

" File search
set path+=**   " Provides tab-completion for all file-related tasks
set wildmenu

" Tags
" The contents of the .ctagsignore file will be ignored by ctags,
" similar to the contents of the Git .gitignore file.
command! Mktags !ctags -R
    \ --exclude=.git
    \ --exclude=.svn
    \ $(test -r .ctagsignore && echo "--exclude=@.ctagsignore")
    \ .
